Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions

# SmoothMover Class Reference

This class handles smoothing of sampled motion points over time, e.g. More...

List of all members.

## Public Types
enum | PredictionMode { PMOff = 0, PMOn = 1 }
enum | SmoothMode { SMOff = 0, SMOn = 1 }
## Public Member Functions
| SmoothMover ()
| applySmoothHpr (NodePath node)
| Applies the smoothed orientation to the indicated NodePath.
| applySmoothPos (NodePath node)
| Applies the smoothed position to the indicated NodePath.
| applySmoothPosHpr (NodePath pos_node, NodePath hpr_node)
| Applies the smoothed position and orientation to the indicated NodePath.
| clearPositions (bool reset_velocity)
| Erases all the old position reports.
| computeAndApplySmoothHpr (NodePath hpr_node)
| A further optimization to reduce Python calls.
| computeAndApplySmoothPos (NodePath node)
| A further optimization to reduce Python calls.
| computeAndApplySmoothPosHpr (NodePath pos_node, NodePath hpr_node)
| A further optimization to reduce Python calls.
bool | computeSmoothPosition (double timestamp)
| Computes the smoothed position (and orientation) of the mover at the indicated point in time, based on the previous position reports.
bool | computeSmoothPosition ()
| Computes the smoothed position (and orientation) of the mover at the indicated point in time, based on the previous position reports.
bool | getAcceptClockSkew ()
| Returns the current state of the 'accept clock skew' flag.
bool | getDefaultToStandingStill ()
| Returns the current state of the 'default to standing still' flag.
double | getDelay ()
| Returns the amount of time, in seconds, to delay the computed position of a SmoothMover.
bool | getDirectionalVelocity ()
| Returns the current state of the 'directional velocity' flag.
double | getExpectedBroadcastPeriod ()
| Returns the interval at which we expect the SmoothNodes to broadcast their position, in elapsed seconds.
VBase3 const | getForwardAxis ()
| Returns the smoothed position as computed by a previous call to compute_smooth_position().
bool | getLatestPosition ()
| Updates the smooth_pos (and smooth_hpr, etc.) members to reflect the absolute latest position known for this avatar.
double | getMaxPositionAge ()
| Returns the maximum amount of time a position is allowed to remain unchanged before assuming it represents the avatar actually standing still.
double | getMostRecentTimestamp ()
| Returns most recently recorded timestamp.
PredictionMode | getPredictionMode ()
| Returns the predictioning mode of all SmoothMovers in the world.
double | getResetVelocityAge ()
| Returns the amount of time that should elapse after the last position report before the velocity is reset to 0.
VBase3 const | getSampleHpr ()
| Returns the current orientation of the working sample point.
Point3 const | getSamplePos ()
| Returns the current position of the working sample point.
float | getSmoothForwardVelocity ()
| Returns the speed at which the avatar is moving, in feet per second, along its own forward axis (after applying the avatar's hpr).
VBase3 const | getSmoothHpr ()
| Returns the smoothed orientation as computed by a previous call to compute_smooth_position().
float | getSmoothLateralVelocity ()
| Returns the speed at which the avatar is moving, in feet per second, along its own lateral axis (after applying the avatar's hpr).
SmoothMode | getSmoothMode ()
| Returns the smoothing mode of all SmoothMovers in the world.
Point3 const | getSmoothPos ()
| Returns the smoothed position as computed by a previous call to compute_smooth_position().
float | getSmoothRotationalVelocity ()
| Returns the speed at which the avatar is rotating in the horizontal plane (i.e.
| handleWrtReparent (NodePath old_parent, NodePath new_parent)
| Node is being wrtReparented, update recorded sample positions to reflect new parent.
bool | hasMostRecentTimestamp ()
| Returns true if we have most recently recorded timestamp.
| markPosition ()
| Stores the position, orientation, and timestamp (if relevant) indicated by previous calls to set_pos(), set_hpr(), and set_timestamp() in a new position report.
| output (ostream out)
| setAcceptClockSkew (bool flag)
| Sets the 'accept clock skew' flag.
| setDefaultToStandingStill (bool flag)
| Sets the flag that indicates whether to assume that the node stopped moving during periods when we don't get enough position updates.
| setDelay (double delay)
| Sets the amount of time, in seconds, to delay the computed position of a SmoothMover.
| setDirectionalVelocity (bool flag)
| Sets the flag that indicates whether the avatar's direction is considered in computing the velocity.
| setExpectedBroadcastPeriod (double period)
| Sets the interval at which we expect the SmoothNodes to broadcast their position, in elapsed seconds.
bool | setH (float h)
| Sets the heading only.
bool | setHpr (float h, float p, float r)
| Specifies the orientation of the SmoothMover at a particular time in the past.
bool | setHpr (VBase3 const hpr)
| Specifies the orientation of the SmoothMover at a particular time in the past.
| setMaxPositionAge (double age)
| Sets the maximum amount of time a position is allowed to remain unchanged before assuming it represents the avatar actually standing still.
bool | setP (float p)
| Sets the pitch only.
| setPhonyTimestamp (double timestamp, bool period_adjust)
| Lies and specifies that the current position report was received now.
| setPhonyTimestamp (double timestamp)
| Lies and specifies that the current position report was received now.
| setPhonyTimestamp ()
| Lies and specifies that the current position report was received now.
bool | setPos (float x, float y, float z)
| Specifies the position of the SmoothMover at a particular time in the past.
bool | setPos (VBase3 const pos)
| Specifies the position of the SmoothMover at a particular time in the past.
bool | setPosHpr (float x, float y, float z, float h, float p, float r)
| Specifies the position of the SmoothMover at a particular time in the past.
bool | setPosHpr (VBase3 const pos, VBase3 const hpr)
| Specifies the position and orientation of the SmoothMover at a particular time in the past.
| setPredictionMode (PredictionMode mode)
| Sets the predictioning mode of all SmoothMovers in the world.
bool | setR (float r)
| Sets the roll only.
| setResetVelocityAge (double age)
| Sets the amount of time that should elapse after the last position report before the velocity is reset to 0.
| setSmoothMode (SmoothMode mode)
| Sets the smoothing mode of all SmoothMovers in the world.
| setTimestamp (double timestamp)
| Specifies the time that the current position report applies.
bool | setX (float x)
| Sets the X position only.
bool | setY (float y)
| Sets the Y position only.
bool | setZ (float z)
| Sets the Z position only.
| write (ostream out)

## Detailed Description

This class handles smoothing of sampled motion points over time, e.g.

for smoothing the apparent movement of remote avatars, whose positions are sent via occasional telemetry updates.

It can operate in any of three modes: off, in which it does not smooth any motion but provides the last position it was told; smoothing only, in which it smooths motion information but never tries to anticipate where the avatar might be going; or full prediction, in which it smooths motion as well as tries to predict the avatar's position in lead of the last position update. The assumption is that all SmoothMovers in the world will be operating in the same mode together.

## Member Enumeration Documentation

enum PredictionMode

Enumerator:

  PMOff |
  PMOn |

enum SmoothMode

Enumerator:

  SMOff |
  SMOn |

## Constructor & Destructor Documentation

SmoothMover | ( |  | ) |

## Member Function Documentation

applySmoothHpr | ( | NodePath | node | ) |

Applies the smoothed orientation to the indicated NodePath.

This is equivalent to calling node.set_hpr(smooth_mover->get_smooth_hpr()). It exists as an optimization only, to avoid the overhead of passing the return value through Python.

applySmoothPos | ( | NodePath | node | ) |

Applies the smoothed position to the indicated NodePath.

This is equivalent to calling node.set_pos(smooth_mover->get_smooth_pos()). It exists as an optimization only, to avoid the overhead of passing the return value through Python.

applySmoothPosHpr | ( | NodePath | pos_node,
|  | NodePath | hpr_node
| ) |  |

Applies the smoothed position and orientation to the indicated NodePath.

This is equivalent to calling node.set_pos_hpr(smooth_mover->get_smooth_pos(), smooth_mover->get_smooth_hpr()). It exists as an optimization only, to avoid the overhead of passing the return value through Python.

clearPositions | ( | bool | reset_velocity | ) |

Erases all the old position reports.

This should be done, for instance, prior to teleporting the avatar to a new position; otherwise, the smoother might try to lerp the avatar there. If reset_velocity is true, the velocity is also reset to 0.

computeAndApplySmoothHpr | ( | NodePath | hpr_node | ) |

A further optimization to reduce Python calls.

This computes the smooth position and applies it to the indicated node or nodes in one call. The pos_node and hpr_node might be the same NodePath.

computeAndApplySmoothPos | ( | NodePath | node | ) |

A further optimization to reduce Python calls.

This computes the smooth position and applies it to the indicated node in one call.

computeAndApplySmoothPosHpr | ( | NodePath | pos_node,
|  | NodePath | hpr_node
| ) |  |

A further optimization to reduce Python calls.

This computes the smooth position and applies it to the indicated node or nodes in one call. The pos_node and hpr_node might be the same NodePath.

bool computeSmoothPosition | ( |  | ) |

Computes the smoothed position (and orientation) of the mover at the indicated point in time, based on the previous position reports.

After this call has been made, get_smooth_pos() etc. may be called to retrieve the smoothed position.

With no parameter, the function uses ClockObject.get_frame_time() as the default time.

bool computeSmoothPosition | ( | double | timestamp | ) |

Computes the smoothed position (and orientation) of the mover at the indicated point in time, based on the previous position reports.

After this call has been made, get_smooth_pos() etc. may be called to retrieve the smoothed position.

The return value is true if the value has changed (or might have changed) since the last call to compute_smooth_position(), or false if it remains the same.

bool getAcceptClockSkew | ( |  | ) |

Returns the current state of the 'accept clock skew' flag.

See set_accept_clock_skew().

bool getDefaultToStandingStill | ( |  | ) |

Returns the current state of the 'default to standing still' flag.

See set_default_to_standing_still().

double getDelay | ( |  | ) |

Returns the amount of time, in seconds, to delay the computed position of a SmoothMover.

See set_delay().

bool getDirectionalVelocity | ( |  | ) |

Returns the current state of the 'directional velocity' flag.

See set_directional_velocity().

double getExpectedBroadcastPeriod | ( |  | ) |

Returns the interval at which we expect the SmoothNodes to broadcast their position, in elapsed seconds.

See set_expected_broadcast_period().

VBase3 const getForwardAxis | ( |  | ) |

Returns the smoothed position as computed by a previous call to compute_smooth_position().

bool getLatestPosition | ( |  | ) |

Updates the smooth_pos (and smooth_hpr, etc.) members to reflect the absolute latest position known for this avatar.

This may result in a pop to the most recent position.

Returns true if the latest position is known, false otherwise.

double getMaxPositionAge | ( |  | ) |

Returns the maximum amount of time a position is allowed to remain unchanged before assuming it represents the avatar actually standing still.

double getMostRecentTimestamp | ( |  | ) |

Returns most recently recorded timestamp.

PredictionMode getPredictionMode | ( |  | ) |

Returns the predictioning mode of all SmoothMovers in the world.

See set_prediction_mode().

double getResetVelocityAge | ( |  | ) |

Returns the amount of time that should elapse after the last position report before the velocity is reset to 0.

See set_reset_velocity_age().

VBase3 const getSampleHpr | ( |  | ) |

Returns the current orientation of the working sample point.

This orientation is updated periodically by set_h(), set_p(), etc., and its current value is copied to the sample point table when mark_position() is called.

Point3 const getSamplePos | ( |  | ) |

Returns the current position of the working sample point.

This position is updated periodically by set_x(), set_y(), etc., and its current value is copied to the sample point table when mark_position() is called.

float getSmoothForwardVelocity | ( |  | ) |

Returns the speed at which the avatar is moving, in feet per second, along its own forward axis (after applying the avatar's hpr).

This will be a positive number if the avatar is moving forward, and a negative number if it is moving backward.

VBase3 const getSmoothHpr | ( |  | ) |

Returns the smoothed orientation as computed by a previous call to compute_smooth_position().

float getSmoothLateralVelocity | ( |  | ) |

Returns the speed at which the avatar is moving, in feet per second, along its own lateral axis (after applying the avatar's hpr).

This will be a positive number if the avatar is moving right, and a negative number if it is moving left.

SmoothMode getSmoothMode | ( |  | ) |

Returns the smoothing mode of all SmoothMovers in the world.

See set_smooth_mode().

Point3 const getSmoothPos | ( |  | ) |

Returns the smoothed position as computed by a previous call to compute_smooth_position().

float getSmoothRotationalVelocity | ( |  | ) |

Returns the speed at which the avatar is rotating in the horizontal plane (i.e.

heading), in degrees per second. This may be positive or negative, according to the direction of rotation.

handleWrtReparent | ( | NodePath | old_parent,
|  | NodePath | new_parent
| ) |  |

Node is being wrtReparented, update recorded sample positions to reflect new parent.

bool hasMostRecentTimestamp | ( |  | ) |

Returns true if we have most recently recorded timestamp.

markPosition | ( |  | ) |

Stores the position, orientation, and timestamp (if relevant) indicated by previous calls to set_pos(), set_hpr(), and set_timestamp() in a new position report.

When compute_smooth_position() is called, it uses these stored position reports to base its computation of the known position.

output | ( | ostream | out | ) |

setAcceptClockSkew | ( | bool | flag | ) |

Sets the 'accept clock skew' flag.

When this flag is true, clock skew from the other clients will be tolerated by delaying each smooth mover's position an additional amount, on top of that specified by set_delay(), based on the measured average latency for timestamp messages received by the client.

In this way, if the other client has significant clock skew with respect to our clock, it will be evident as a large positive or negative average latency for timestamps. By subtracting out this average latency, we compensate for poor clock sync.

setDefaultToStandingStill | ( | bool | flag | ) |

Sets the flag that indicates whether to assume that the node stopped moving during periods when we don't get enough position updates.

If true, the object will stand still momentarily. If false, the object will continuously lerp between the position updates that we did get.

setDelay | ( | double | delay | ) |

Sets the amount of time, in seconds, to delay the computed position of a SmoothMover.

This is particularly useful when the prediction mode is off, because it can allow the apparent motion of an avatar to appear smooth without relying on prediction, at the cost of introducing additional lag in the avatar's apparent position.

setDirectionalVelocity | ( | bool | flag | ) |

Sets the flag that indicates whether the avatar's direction is considered in computing the velocity.

When this is true, velocity is automatically decomposed into a forward and a lateral velocity (and both may be positive or negative); when it is false, all velocity is always returned as forward velocity (and it is always positive).

setExpectedBroadcastPeriod | ( | double | period | ) |

Sets the interval at which we expect the SmoothNodes to broadcast their position, in elapsed seconds.

This controls the length of time we assume the object has truly stopped, when we receive a long sequence of no updates.

bool setH | ( | float | h | ) |

Sets the heading only.

See set_hpr().

bool setHpr | ( | VBase3 const | hpr | ) |

Specifies the orientation of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with hpr and timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_hpr(), or false if they are the same.

bool setHpr | ( | float | h,
|  | float | p,
|  | float | r
| ) |  |

Specifies the orientation of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with hpr and timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_hpr(), or false if they are the same.

setMaxPositionAge | ( | double | age | ) |

Sets the maximum amount of time a position is allowed to remain unchanged before assuming it represents the avatar actually standing still.

bool setP | ( | float | p | ) |

Sets the pitch only.

See set_hpr().

setPhonyTimestamp | ( |  | ) |

Lies and specifies that the current position report was received now.

This is usually used for very old position reports for which we're not sure of the actual receipt time.

setPhonyTimestamp | ( | double | timestamp | ) |

Lies and specifies that the current position report was received now.

This is usually used for very old position reports for which we're not sure of the actual receipt time.

setPhonyTimestamp | ( | double | timestamp,
|  | bool | period_adjust
| ) |  |

Lies and specifies that the current position report was received now.

This is usually used for very old position reports for which we're not sure of the actual receipt time.

bool setPos | ( | VBase3 const | pos | ) |

Specifies the position of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with hpr and timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_pos(), or false if they are the same.

bool setPos | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Specifies the position of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with hpr and timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_pos(), or false if they are the same.

bool setPosHpr | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Specifies the position of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_pos_hpr(), or false if they are the same.

bool setPosHpr | ( | VBase3 const | pos,
|  | VBase3 const | hpr
| ) |  |

Specifies the position and orientation of the SmoothMover at a particular time in the past.

When mark_position() is called, this will be recorded (along with timestamp) in a position report, which will then be used along with all other position reports to determine the smooth position at any particular instant.

The return value is true if any parameter has changed since the last call to set_pos_hpr(), or false if they are the same.

setPredictionMode | ( | PredictionMode | mode | ) |

Sets the predictioning mode of all SmoothMovers in the world.

If this is PM_off, no prediction will be performed, but smoothing might still be performed.

bool setR | ( | float | r | ) |

Sets the roll only.

See set_hpr().

setResetVelocityAge | ( | double | age | ) |

Sets the amount of time that should elapse after the last position report before the velocity is reset to 0.

This is similar to max_position_age, but it is only used to determine the resetting of the reported velocity. It should always be greater than or equal to max_position_age.

setSmoothMode | ( | SmoothMode | mode | ) |

Sets the smoothing mode of all SmoothMovers in the world.

If this is SM_off, no smoothing or prediction will be performed, and get_smooth_pos() will simply return the position last set by mark_position().

setTimestamp | ( | double | timestamp | ) |

Specifies the time that the current position report applies.

This should be called, along with set_pos() and set_hpr(), before a call to mark_position().

bool setX | ( | float | x | ) |

Sets the X position only.

See set_pos().

bool setY | ( | float | y | ) |

Sets the Y position only.

See set_pos().

bool setZ | ( | float | z | ) |

Sets the Z position only.

See set_pos().

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties